<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/env_logger-0.9.0/src/fmt/mod.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>mod.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="icon" href="https://www.rust-lang.org/static/images/favicon.ico"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../env_logger/index.html"><div class="logo-container"><img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../env_logger/index.html"><div class="logo-container">
                    <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../env_logger/index.html">
                        <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
<span id="448">448</span>
<span id="449">449</span>
<span id="450">450</span>
<span id="451">451</span>
<span id="452">452</span>
<span id="453">453</span>
<span id="454">454</span>
<span id="455">455</span>
<span id="456">456</span>
<span id="457">457</span>
<span id="458">458</span>
<span id="459">459</span>
<span id="460">460</span>
<span id="461">461</span>
<span id="462">462</span>
<span id="463">463</span>
<span id="464">464</span>
<span id="465">465</span>
<span id="466">466</span>
<span id="467">467</span>
<span id="468">468</span>
<span id="469">469</span>
<span id="470">470</span>
<span id="471">471</span>
<span id="472">472</span>
<span id="473">473</span>
<span id="474">474</span>
<span id="475">475</span>
<span id="476">476</span>
<span id="477">477</span>
<span id="478">478</span>
<span id="479">479</span>
<span id="480">480</span>
<span id="481">481</span>
<span id="482">482</span>
<span id="483">483</span>
<span id="484">484</span>
<span id="485">485</span>
<span id="486">486</span>
<span id="487">487</span>
<span id="488">488</span>
<span id="489">489</span>
<span id="490">490</span>
<span id="491">491</span>
<span id="492">492</span>
<span id="493">493</span>
<span id="494">494</span>
<span id="495">495</span>
<span id="496">496</span>
<span id="497">497</span>
<span id="498">498</span>
<span id="499">499</span>
<span id="500">500</span>
<span id="501">501</span>
<span id="502">502</span>
<span id="503">503</span>
<span id="504">504</span>
<span id="505">505</span>
<span id="506">506</span>
<span id="507">507</span>
<span id="508">508</span>
<span id="509">509</span>
<span id="510">510</span>
<span id="511">511</span>
<span id="512">512</span>
<span id="513">513</span>
<span id="514">514</span>
<span id="515">515</span>
<span id="516">516</span>
<span id="517">517</span>
<span id="518">518</span>
<span id="519">519</span>
<span id="520">520</span>
<span id="521">521</span>
<span id="522">522</span>
<span id="523">523</span>
<span id="524">524</span>
<span id="525">525</span>
<span id="526">526</span>
<span id="527">527</span>
<span id="528">528</span>
<span id="529">529</span>
<span id="530">530</span>
<span id="531">531</span>
<span id="532">532</span>
<span id="533">533</span>
<span id="534">534</span>
<span id="535">535</span>
<span id="536">536</span>
<span id="537">537</span>
<span id="538">538</span>
<span id="539">539</span>
<span id="540">540</span>
<span id="541">541</span>
<span id="542">542</span>
<span id="543">543</span>
<span id="544">544</span>
<span id="545">545</span>
<span id="546">546</span>
<span id="547">547</span>
<span id="548">548</span>
<span id="549">549</span>
<span id="550">550</span>
<span id="551">551</span>
<span id="552">552</span>
<span id="553">553</span>
<span id="554">554</span>
<span id="555">555</span>
<span id="556">556</span>
<span id="557">557</span>
<span id="558">558</span>
<span id="559">559</span>
<span id="560">560</span>
<span id="561">561</span>
<span id="562">562</span>
<span id="563">563</span>
<span id="564">564</span>
<span id="565">565</span>
<span id="566">566</span>
<span id="567">567</span>
<span id="568">568</span>
<span id="569">569</span>
<span id="570">570</span>
<span id="571">571</span>
<span id="572">572</span>
<span id="573">573</span>
<span id="574">574</span>
<span id="575">575</span>
<span id="576">576</span>
<span id="577">577</span>
<span id="578">578</span>
<span id="579">579</span>
<span id="580">580</span>
<span id="581">581</span>
<span id="582">582</span>
<span id="583">583</span>
<span id="584">584</span>
<span id="585">585</span>
<span id="586">586</span>
<span id="587">587</span>
<span id="588">588</span>
<span id="589">589</span>
<span id="590">590</span>
<span id="591">591</span>
<span id="592">592</span>
<span id="593">593</span>
<span id="594">594</span>
<span id="595">595</span>
<span id="596">596</span>
<span id="597">597</span>
<span id="598">598</span>
<span id="599">599</span>
<span id="600">600</span>
<span id="601">601</span>
<span id="602">602</span>
<span id="603">603</span>
<span id="604">604</span>
<span id="605">605</span>
<span id="606">606</span>
<span id="607">607</span>
<span id="608">608</span>
<span id="609">609</span>
<span id="610">610</span>
<span id="611">611</span>
<span id="612">612</span>
<span id="613">613</span>
<span id="614">614</span>
<span id="615">615</span>
<span id="616">616</span>
<span id="617">617</span>
<span id="618">618</span>
<span id="619">619</span>
<span id="620">620</span>
<span id="621">621</span>
<span id="622">622</span>
<span id="623">623</span>
<span id="624">624</span>
<span id="625">625</span>
<span id="626">626</span>
<span id="627">627</span>
<span id="628">628</span>
<span id="629">629</span>
<span id="630">630</span>
<span id="631">631</span>
<span id="632">632</span>
<span id="633">633</span>
<span id="634">634</span>
<span id="635">635</span>
<span id="636">636</span>
<span id="637">637</span>
<span id="638">638</span>
<span id="639">639</span>
<span id="640">640</span>
<span id="641">641</span>
<span id="642">642</span>
<span id="643">643</span>
<span id="644">644</span>
<span id="645">645</span>
<span id="646">646</span>
<span id="647">647</span>
<span id="648">648</span>
<span id="649">649</span>
<span id="650">650</span>
<span id="651">651</span>
<span id="652">652</span>
</pre><pre class="rust"><code><span class="doccomment">//! Formatting for log records.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This module contains a [`Formatter`] that can be used to format log records</span>
<span class="doccomment">//! into without needing temporary allocations. Usually you won&#39;t need to worry</span>
<span class="doccomment">//! about the contents of this module and can use the `Formatter` like an ordinary</span>
<span class="doccomment">//! [`Write`].</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Formatting log records</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The format used to print log records can be customised using the [`Builder::format`]</span>
<span class="doccomment">//! method.</span>
<span class="doccomment">//! Custom formats can apply different color and weight to printed values using</span>
<span class="doccomment">//! [`Style`] builders.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//! use std::io::Write;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! let mut builder = env_logger::Builder::new();</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! builder.format(|buf, record| {</span>
<span class="doccomment">//!     writeln!(buf, &quot;{}: {}&quot;,</span>
<span class="doccomment">//!         record.level(),</span>
<span class="doccomment">//!         record.args())</span>
<span class="doccomment">//! });</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [`Formatter`]: struct.Formatter.html</span>
<span class="doccomment">//! [`Style`]: struct.Style.html</span>
<span class="doccomment">//! [`Builder::format`]: ../struct.Builder.html#method.format</span>
<span class="doccomment">//! [`Write`]: https://doc.rust-lang.org/stable/std/io/trait.Write.html</span>

<span class="kw">use</span> <span class="ident">std::cell::RefCell</span>;
<span class="kw">use</span> <span class="ident">std::fmt::Display</span>;
<span class="kw">use</span> <span class="ident">std::io::prelude</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">std::rc::Rc</span>;
<span class="kw">use</span> <span class="ident">std</span>::{<span class="ident">fmt</span>, <span class="ident">io</span>, <span class="ident">mem</span>};

<span class="kw">use</span> <span class="ident">log::Record</span>;

<span class="kw">mod</span> <span class="ident">humantime</span>;
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">mod</span> <span class="ident">writer</span>;

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::humantime::glob</span>::<span class="kw-2">*</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::writer::glob</span>::<span class="kw-2">*</span>;

<span class="kw">use</span> <span class="ident"><span class="self">self</span>::writer</span>::{<span class="ident">Buffer</span>, <span class="ident">Writer</span>};

<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">mod</span> <span class="ident">glob</span> {
    <span class="kw">pub</span> <span class="kw">use</span> <span class="kw">super</span>::{<span class="ident">Target</span>, <span class="ident">TimestampPrecision</span>, <span class="ident">WriteStyle</span>};
}

<span class="doccomment">/// Formatting precision of timestamps.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Seconds give precision of full seconds, milliseconds give thousands of a</span>
<span class="doccomment">/// second (3 decimal digits), microseconds are millionth of a second (6 decimal</span>
<span class="doccomment">/// digits) and nanoseconds are billionth of a second (9 decimal digits).</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Copy</span>, <span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">TimestampPrecision</span> {
    <span class="doccomment">/// Full second precision (0 decimal digits)</span>
    <span class="ident">Seconds</span>,
    <span class="doccomment">/// Millisecond precision (3 decimal digits)</span>
    <span class="ident">Millis</span>,
    <span class="doccomment">/// Microsecond precision (6 decimal digits)</span>
    <span class="ident">Micros</span>,
    <span class="doccomment">/// Nanosecond precision (9 decimal digits)</span>
    <span class="ident">Nanos</span>,
}

<span class="doccomment">/// The default timestamp precision is seconds.</span>
<span class="kw">impl</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">TimestampPrecision</span> {
    <span class="kw">fn</span> <span class="ident">default</span>() -&gt; <span class="self">Self</span> {
        <span class="ident">TimestampPrecision::Seconds</span>
    }
}

<span class="doccomment">/// A formatter to write logs into.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// `Formatter` implements the standard [`Write`] trait for writing log records.</span>
<span class="doccomment">/// It also supports terminal colors, through the [`style`] method.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Use the [`writeln`] macro to format a log record.</span>
<span class="doccomment">/// An instance of a `Formatter` is passed to an `env_logger` format as `buf`:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use std::io::Write;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// let mut builder = env_logger::Builder::new();</span>
<span class="doccomment">///</span>
<span class="doccomment">/// builder.format(|buf, record| writeln!(buf, &quot;{}: {}&quot;, record.level(), record.args()));</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [`Write`]: https://doc.rust-lang.org/stable/std/io/trait.Write.html</span>
<span class="doccomment">/// [`writeln`]: https://doc.rust-lang.org/stable/std/macro.writeln.html</span>
<span class="doccomment">/// [`style`]: #method.style</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Formatter</span> {
    <span class="ident">buf</span>: <span class="ident">Rc</span><span class="op">&lt;</span><span class="ident">RefCell</span><span class="op">&lt;</span><span class="ident">Buffer</span><span class="op">&gt;</span><span class="op">&gt;</span>,
    <span class="ident">write_style</span>: <span class="ident">WriteStyle</span>,
}

<span class="kw">impl</span> <span class="ident">Formatter</span> {
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">writer</span>: <span class="kw-2">&amp;</span><span class="ident">Writer</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">Formatter</span> {
            <span class="ident">buf</span>: <span class="ident">Rc::new</span>(<span class="ident">RefCell::new</span>(<span class="ident">writer</span>.<span class="ident">buffer</span>())),
            <span class="ident">write_style</span>: <span class="ident">writer</span>.<span class="ident">write_style</span>(),
        }
    }

    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">write_style</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">WriteStyle</span> {
        <span class="self">self</span>.<span class="ident">write_style</span>
    }

    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">print</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">writer</span>: <span class="kw-2">&amp;</span><span class="ident">Writer</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="ident">writer</span>.<span class="ident">print</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">buf</span>.<span class="ident">borrow</span>())
    }

    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">clear</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) {
        <span class="self">self</span>.<span class="ident">buf</span>.<span class="ident">borrow_mut</span>().<span class="ident">clear</span>()
    }
}

<span class="kw">impl</span> <span class="ident">Write</span> <span class="kw">for</span> <span class="ident">Formatter</span> {
    <span class="kw">fn</span> <span class="ident">write</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">buf</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">buf</span>.<span class="ident">borrow_mut</span>().<span class="ident">write</span>(<span class="ident">buf</span>)
    }

    <span class="kw">fn</span> <span class="ident">flush</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">buf</span>.<span class="ident">borrow_mut</span>().<span class="ident">flush</span>()
    }
}

<span class="kw">impl</span> <span class="ident">fmt::Debug</span> <span class="kw">for</span> <span class="ident">Formatter</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="ident">f</span>.<span class="ident">debug_struct</span>(<span class="string">&quot;Formatter&quot;</span>).<span class="ident">finish</span>()
    }
}

<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">type</span> <span class="ident">FormatFn</span> <span class="op">=</span> <span class="ident">Box</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">Fn</span>(<span class="kw-2">&amp;mut</span> <span class="ident">Formatter</span>, <span class="kw-2">&amp;</span><span class="ident">Record</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> <span class="op">+</span> <span class="ident">Sync</span> <span class="op">+</span> <span class="ident">Send</span><span class="op">&gt;</span>;

<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">struct</span> <span class="ident">Builder</span> {
    <span class="kw">pub</span> <span class="ident">format_timestamp</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">TimestampPrecision</span><span class="op">&gt;</span>,
    <span class="kw">pub</span> <span class="ident">format_module_path</span>: <span class="ident">bool</span>,
    <span class="kw">pub</span> <span class="ident">format_target</span>: <span class="ident">bool</span>,
    <span class="kw">pub</span> <span class="ident">format_level</span>: <span class="ident">bool</span>,
    <span class="kw">pub</span> <span class="ident">format_indent</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>,
    <span class="kw">pub</span> <span class="ident">custom_format</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">FormatFn</span><span class="op">&gt;</span>,
    <span class="kw">pub</span> <span class="ident">format_suffix</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span>,
    <span class="ident">built</span>: <span class="ident">bool</span>,
}

<span class="kw">impl</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">Builder</span> {
    <span class="kw">fn</span> <span class="ident">default</span>() -&gt; <span class="self">Self</span> {
        <span class="ident">Builder</span> {
            <span class="ident">format_timestamp</span>: <span class="prelude-val">Some</span>(<span class="ident">Default::default</span>()),
            <span class="ident">format_module_path</span>: <span class="bool-val">false</span>,
            <span class="ident">format_target</span>: <span class="bool-val">true</span>,
            <span class="ident">format_level</span>: <span class="bool-val">true</span>,
            <span class="ident">format_indent</span>: <span class="prelude-val">Some</span>(<span class="number">4</span>),
            <span class="ident">custom_format</span>: <span class="prelude-val">None</span>,
            <span class="ident">format_suffix</span>: <span class="string">&quot;\n&quot;</span>,
            <span class="ident">built</span>: <span class="bool-val">false</span>,
        }
    }
}

<span class="kw">impl</span> <span class="ident">Builder</span> {
    <span class="doccomment">/// Convert the format into a callable function.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// If the `custom_format` is `Some`, then any `default_format` switches are ignored.</span>
    <span class="doccomment">/// If the `custom_format` is `None`, then a default format is returned.</span>
    <span class="doccomment">/// Any `default_format` switches set to `false` won&#39;t be written by the format.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">build</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="ident">FormatFn</span> {
        <span class="macro">assert!</span>(<span class="op">!</span><span class="self">self</span>.<span class="ident">built</span>, <span class="string">&quot;attempt to re-use consumed builder&quot;</span>);

        <span class="kw">let</span> <span class="ident">built</span> <span class="op">=</span> <span class="ident">mem::replace</span>(
            <span class="self">self</span>,
            <span class="ident">Builder</span> {
                <span class="ident">built</span>: <span class="bool-val">true</span>,
                ..<span class="ident">Default::default</span>()
            },
        );

        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">fmt</span>) <span class="op">=</span> <span class="ident">built</span>.<span class="ident">custom_format</span> {
            <span class="ident">fmt</span>
        } <span class="kw">else</span> {
            <span class="ident">Box::new</span>(<span class="kw">move</span> <span class="op">|</span><span class="ident">buf</span>, <span class="ident">record</span><span class="op">|</span> {
                <span class="kw">let</span> <span class="ident">fmt</span> <span class="op">=</span> <span class="ident">DefaultFormat</span> {
                    <span class="ident">timestamp</span>: <span class="ident">built</span>.<span class="ident">format_timestamp</span>,
                    <span class="ident">module_path</span>: <span class="ident">built</span>.<span class="ident">format_module_path</span>,
                    <span class="ident">target</span>: <span class="ident">built</span>.<span class="ident">format_target</span>,
                    <span class="ident">level</span>: <span class="ident">built</span>.<span class="ident">format_level</span>,
                    <span class="ident">written_header_value</span>: <span class="bool-val">false</span>,
                    <span class="ident">indent</span>: <span class="ident">built</span>.<span class="ident">format_indent</span>,
                    <span class="ident">suffix</span>: <span class="ident">built</span>.<span class="ident">format_suffix</span>,
                    <span class="ident">buf</span>,
                };

                <span class="ident">fmt</span>.<span class="ident">write</span>(<span class="ident">record</span>)
            })
        }
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;termcolor&quot;</span>)]</span>
<span class="kw">type</span> <span class="ident">SubtleStyle</span> <span class="op">=</span> <span class="ident">StyledValue</span><span class="op">&lt;</span><span class="lifetime">&#39;static</span>, <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span><span class="op">&gt;</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;termcolor&quot;</span>))]</span>
<span class="kw">type</span> <span class="ident">SubtleStyle</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span>;

<span class="doccomment">/// The default format.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This format needs to work with any combination of crate features.</span>
<span class="kw">struct</span> <span class="ident">DefaultFormat</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="ident">timestamp</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">TimestampPrecision</span><span class="op">&gt;</span>,
    <span class="ident">module_path</span>: <span class="ident">bool</span>,
    <span class="ident">target</span>: <span class="ident">bool</span>,
    <span class="ident">level</span>: <span class="ident">bool</span>,
    <span class="ident">written_header_value</span>: <span class="ident">bool</span>,
    <span class="ident">indent</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>,
    <span class="ident">buf</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> <span class="ident">Formatter</span>,
    <span class="ident">suffix</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">DefaultFormat</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">write</span>(<span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">record</span>: <span class="kw-2">&amp;</span><span class="ident">Record</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">write_timestamp</span>()<span class="question-mark">?</span>;
        <span class="self">self</span>.<span class="ident">write_level</span>(<span class="ident">record</span>)<span class="question-mark">?</span>;
        <span class="self">self</span>.<span class="ident">write_module_path</span>(<span class="ident">record</span>)<span class="question-mark">?</span>;
        <span class="self">self</span>.<span class="ident">write_target</span>(<span class="ident">record</span>)<span class="question-mark">?</span>;
        <span class="self">self</span>.<span class="ident">finish_header</span>()<span class="question-mark">?</span>;

        <span class="self">self</span>.<span class="ident">write_args</span>(<span class="ident">record</span>)
    }

    <span class="kw">fn</span> <span class="ident">subtle_style</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">text</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span>) -&gt; <span class="ident">SubtleStyle</span> {
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;termcolor&quot;</span>)]</span>
        {
            <span class="self">self</span>.<span class="ident">buf</span>
                .<span class="ident">style</span>()
                .<span class="ident">set_color</span>(<span class="ident">Color::Black</span>)
                .<span class="ident">set_intense</span>(<span class="bool-val">true</span>)
                .<span class="ident">clone</span>()
                .<span class="ident">into_value</span>(<span class="ident">text</span>)
        }
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;termcolor&quot;</span>))]</span>
        {
            <span class="ident">text</span>
        }
    }

    <span class="kw">fn</span> <span class="ident">write_header_value</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">value</span>: <span class="ident">T</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span>
    <span class="kw">where</span>
        <span class="ident">T</span>: <span class="ident">Display</span>,
    {
        <span class="kw">if</span> <span class="op">!</span><span class="self">self</span>.<span class="ident">written_header_value</span> {
            <span class="self">self</span>.<span class="ident">written_header_value</span> <span class="op">=</span> <span class="bool-val">true</span>;

            <span class="kw">let</span> <span class="ident">open_brace</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">subtle_style</span>(<span class="string">&quot;[&quot;</span>);
            <span class="macro">write!</span>(<span class="self">self</span>.<span class="ident">buf</span>, <span class="string">&quot;{}{}&quot;</span>, <span class="ident">open_brace</span>, <span class="ident">value</span>)
        } <span class="kw">else</span> {
            <span class="macro">write!</span>(<span class="self">self</span>.<span class="ident">buf</span>, <span class="string">&quot; {}&quot;</span>, <span class="ident">value</span>)
        }
    }

    <span class="kw">fn</span> <span class="ident">write_level</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">record</span>: <span class="kw-2">&amp;</span><span class="ident">Record</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="op">!</span><span class="self">self</span>.<span class="ident">level</span> {
            <span class="kw">return</span> <span class="prelude-val">Ok</span>(());
        }

        <span class="kw">let</span> <span class="ident">level</span> <span class="op">=</span> {
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;termcolor&quot;</span>)]</span>
            {
                <span class="self">self</span>.<span class="ident">buf</span>.<span class="ident">default_styled_level</span>(<span class="ident">record</span>.<span class="ident">level</span>())
            }
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;termcolor&quot;</span>))]</span>
            {
                <span class="ident">record</span>.<span class="ident">level</span>()
            }
        };

        <span class="self">self</span>.<span class="ident">write_header_value</span>(<span class="macro">format_args!</span>(<span class="string">&quot;{:&lt;5}&quot;</span>, <span class="ident">level</span>))
    }

    <span class="kw">fn</span> <span class="ident">write_timestamp</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;humantime&quot;</span>)]</span>
        {
            <span class="kw">use</span> <span class="ident"><span class="self">self</span>::TimestampPrecision</span>::<span class="kw-2">*</span>;
            <span class="kw">let</span> <span class="ident">ts</span> <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>.<span class="ident">timestamp</span> {
                <span class="prelude-val">None</span> =&gt; <span class="kw">return</span> <span class="prelude-val">Ok</span>(()),
                <span class="prelude-val">Some</span>(<span class="ident">Seconds</span>) =&gt; <span class="self">self</span>.<span class="ident">buf</span>.<span class="ident">timestamp_seconds</span>(),
                <span class="prelude-val">Some</span>(<span class="ident">Millis</span>) =&gt; <span class="self">self</span>.<span class="ident">buf</span>.<span class="ident">timestamp_millis</span>(),
                <span class="prelude-val">Some</span>(<span class="ident">Micros</span>) =&gt; <span class="self">self</span>.<span class="ident">buf</span>.<span class="ident">timestamp_micros</span>(),
                <span class="prelude-val">Some</span>(<span class="ident">Nanos</span>) =&gt; <span class="self">self</span>.<span class="ident">buf</span>.<span class="ident">timestamp_nanos</span>(),
            };

            <span class="self">self</span>.<span class="ident">write_header_value</span>(<span class="ident">ts</span>)
        }
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;humantime&quot;</span>))]</span>
        {
            <span class="comment">// Trick the compiler to think we have used self.timestamp</span>
            <span class="comment">// Workaround for &quot;field is never used: `timestamp`&quot; compiler nag.</span>
            <span class="kw">let</span> <span class="kw">_</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">timestamp</span>;
            <span class="prelude-val">Ok</span>(())
        }
    }

    <span class="kw">fn</span> <span class="ident">write_module_path</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">record</span>: <span class="kw-2">&amp;</span><span class="ident">Record</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="op">!</span><span class="self">self</span>.<span class="ident">module_path</span> {
            <span class="kw">return</span> <span class="prelude-val">Ok</span>(());
        }

        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">module_path</span>) <span class="op">=</span> <span class="ident">record</span>.<span class="ident">module_path</span>() {
            <span class="self">self</span>.<span class="ident">write_header_value</span>(<span class="ident">module_path</span>)
        } <span class="kw">else</span> {
            <span class="prelude-val">Ok</span>(())
        }
    }

    <span class="kw">fn</span> <span class="ident">write_target</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">record</span>: <span class="kw-2">&amp;</span><span class="ident">Record</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="op">!</span><span class="self">self</span>.<span class="ident">target</span> {
            <span class="kw">return</span> <span class="prelude-val">Ok</span>(());
        }

        <span class="kw">match</span> <span class="ident">record</span>.<span class="ident">target</span>() {
            <span class="string">&quot;&quot;</span> =&gt; <span class="prelude-val">Ok</span>(()),
            <span class="ident">target</span> =&gt; <span class="self">self</span>.<span class="ident">write_header_value</span>(<span class="ident">target</span>),
        }
    }

    <span class="kw">fn</span> <span class="ident">finish_header</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">written_header_value</span> {
            <span class="kw">let</span> <span class="ident">close_brace</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">subtle_style</span>(<span class="string">&quot;]&quot;</span>);
            <span class="macro">write!</span>(<span class="self">self</span>.<span class="ident">buf</span>, <span class="string">&quot;{} &quot;</span>, <span class="ident">close_brace</span>)
        } <span class="kw">else</span> {
            <span class="prelude-val">Ok</span>(())
        }
    }

    <span class="kw">fn</span> <span class="ident">write_args</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">record</span>: <span class="kw-2">&amp;</span><span class="ident">Record</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">indent</span> {
            <span class="comment">// Fast path for no indentation</span>
            <span class="prelude-val">None</span> =&gt; <span class="macro">write!</span>(<span class="self">self</span>.<span class="ident">buf</span>, <span class="string">&quot;{}{}&quot;</span>, <span class="ident">record</span>.<span class="ident">args</span>(), <span class="self">self</span>.<span class="ident">suffix</span>),

            <span class="prelude-val">Some</span>(<span class="ident">indent_count</span>) =&gt; {
                <span class="comment">// Create a wrapper around the buffer only if we have to actually indent the message</span>

                <span class="kw">struct</span> <span class="ident">IndentWrapper</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="lifetime">&#39;b</span>: <span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
                    <span class="ident">fmt</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> <span class="ident">DefaultFormat</span><span class="op">&lt;</span><span class="lifetime">&#39;b</span><span class="op">&gt;</span>,
                    <span class="ident">indent_count</span>: <span class="ident">usize</span>,
                }

                <span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="lifetime">&#39;b</span><span class="op">&gt;</span> <span class="ident">Write</span> <span class="kw">for</span> <span class="ident">IndentWrapper</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="lifetime">&#39;b</span><span class="op">&gt;</span> {
                    <span class="kw">fn</span> <span class="ident">write</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">buf</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
                        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">first</span> <span class="op">=</span> <span class="bool-val">true</span>;
                        <span class="kw">for</span> <span class="ident">chunk</span> <span class="kw">in</span> <span class="ident">buf</span>.<span class="ident">split</span>(<span class="op">|</span><span class="kw-2">&amp;</span><span class="ident">x</span><span class="op">|</span> <span class="ident">x</span> <span class="op">==</span> <span class="string">b&#39;\n&#39;</span>) {
                            <span class="kw">if</span> <span class="op">!</span><span class="ident">first</span> {
                                <span class="macro">write!</span>(
                                    <span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">buf</span>,
                                    <span class="string">&quot;{}{:width$}&quot;</span>,
                                    <span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">suffix</span>,
                                    <span class="string">&quot;&quot;</span>,
                                    <span class="ident">width</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">indent_count</span>
                                )<span class="question-mark">?</span>;
                            }
                            <span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">buf</span>.<span class="ident">write_all</span>(<span class="ident">chunk</span>)<span class="question-mark">?</span>;
                            <span class="ident">first</span> <span class="op">=</span> <span class="bool-val">false</span>;
                        }

                        <span class="prelude-val">Ok</span>(<span class="ident">buf</span>.<span class="ident">len</span>())
                    }

                    <span class="kw">fn</span> <span class="ident">flush</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
                        <span class="self">self</span>.<span class="ident">fmt</span>.<span class="ident">buf</span>.<span class="ident">flush</span>()
                    }
                }

                <span class="comment">// The explicit scope here is just to make older versions of Rust happy</span>
                {
                    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">wrapper</span> <span class="op">=</span> <span class="ident">IndentWrapper</span> {
                        <span class="ident">fmt</span>: <span class="self">self</span>,
                        <span class="ident">indent_count</span>,
                    };
                    <span class="macro">write!</span>(<span class="ident">wrapper</span>, <span class="string">&quot;{}&quot;</span>, <span class="ident">record</span>.<span class="ident">args</span>())<span class="question-mark">?</span>;
                }

                <span class="macro">write!</span>(<span class="self">self</span>.<span class="ident">buf</span>, <span class="string">&quot;{}&quot;</span>, <span class="self">self</span>.<span class="ident">suffix</span>)<span class="question-mark">?</span>;

                <span class="prelude-val">Ok</span>(())
            }
        }
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">tests</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;

    <span class="kw">use</span> <span class="ident">log</span>::{<span class="ident">Level</span>, <span class="ident">Record</span>};

    <span class="kw">fn</span> <span class="ident">write_record</span>(<span class="ident">record</span>: <span class="ident">Record</span>, <span class="ident">fmt</span>: <span class="ident">DefaultFormat</span>) -&gt; <span class="ident">String</span> {
        <span class="kw">let</span> <span class="ident">buf</span> <span class="op">=</span> <span class="ident">fmt</span>.<span class="ident">buf</span>.<span class="ident">buf</span>.<span class="ident">clone</span>();

        <span class="ident">fmt</span>.<span class="ident">write</span>(<span class="kw-2">&amp;</span><span class="ident">record</span>).<span class="ident">expect</span>(<span class="string">&quot;failed to write record&quot;</span>);

        <span class="kw">let</span> <span class="ident">buf</span> <span class="op">=</span> <span class="ident">buf</span>.<span class="ident">borrow</span>();
        <span class="ident">String::from_utf8</span>(<span class="ident">buf</span>.<span class="ident">bytes</span>().<span class="ident">to_vec</span>()).<span class="ident">expect</span>(<span class="string">&quot;failed to read record&quot;</span>)
    }

    <span class="kw">fn</span> <span class="ident">write_target</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>(<span class="ident">target</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">fmt</span>: <span class="ident">DefaultFormat</span>) -&gt; <span class="ident">String</span> {
        <span class="ident">write_record</span>(
            <span class="ident">Record::builder</span>()
                .<span class="ident">args</span>(<span class="macro">format_args!</span>(<span class="string">&quot;log\nmessage&quot;</span>))
                .<span class="ident">level</span>(<span class="ident">Level::Info</span>)
                .<span class="ident">file</span>(<span class="prelude-val">Some</span>(<span class="string">&quot;test.rs&quot;</span>))
                .<span class="ident">line</span>(<span class="prelude-val">Some</span>(<span class="number">144</span>))
                .<span class="ident">module_path</span>(<span class="prelude-val">Some</span>(<span class="string">&quot;test::path&quot;</span>))
                .<span class="ident">target</span>(<span class="ident">target</span>)
                .<span class="ident">build</span>(),
            <span class="ident">fmt</span>,
        )
    }

    <span class="kw">fn</span> <span class="ident">write</span>(<span class="ident">fmt</span>: <span class="ident">DefaultFormat</span>) -&gt; <span class="ident">String</span> {
        <span class="ident">write_target</span>(<span class="string">&quot;&quot;</span>, <span class="ident">fmt</span>)
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">format_with_header</span>() {
        <span class="kw">let</span> <span class="ident">writer</span> <span class="op">=</span> <span class="ident">writer::Builder::new</span>()
            .<span class="ident">write_style</span>(<span class="ident">WriteStyle::Never</span>)
            .<span class="ident">build</span>();

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">f</span> <span class="op">=</span> <span class="ident">Formatter::new</span>(<span class="kw-2">&amp;</span><span class="ident">writer</span>);

        <span class="kw">let</span> <span class="ident">written</span> <span class="op">=</span> <span class="ident">write</span>(<span class="ident">DefaultFormat</span> {
            <span class="ident">timestamp</span>: <span class="prelude-val">None</span>,
            <span class="ident">module_path</span>: <span class="bool-val">true</span>,
            <span class="ident">target</span>: <span class="bool-val">false</span>,
            <span class="ident">level</span>: <span class="bool-val">true</span>,
            <span class="ident">written_header_value</span>: <span class="bool-val">false</span>,
            <span class="ident">indent</span>: <span class="prelude-val">None</span>,
            <span class="ident">suffix</span>: <span class="string">&quot;\n&quot;</span>,
            <span class="ident">buf</span>: <span class="kw-2">&amp;mut</span> <span class="ident">f</span>,
        });

        <span class="macro">assert_eq!</span>(<span class="string">&quot;[INFO  test::path] log\nmessage\n&quot;</span>, <span class="ident">written</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">format_no_header</span>() {
        <span class="kw">let</span> <span class="ident">writer</span> <span class="op">=</span> <span class="ident">writer::Builder::new</span>()
            .<span class="ident">write_style</span>(<span class="ident">WriteStyle::Never</span>)
            .<span class="ident">build</span>();

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">f</span> <span class="op">=</span> <span class="ident">Formatter::new</span>(<span class="kw-2">&amp;</span><span class="ident">writer</span>);

        <span class="kw">let</span> <span class="ident">written</span> <span class="op">=</span> <span class="ident">write</span>(<span class="ident">DefaultFormat</span> {
            <span class="ident">timestamp</span>: <span class="prelude-val">None</span>,
            <span class="ident">module_path</span>: <span class="bool-val">false</span>,
            <span class="ident">target</span>: <span class="bool-val">false</span>,
            <span class="ident">level</span>: <span class="bool-val">false</span>,
            <span class="ident">written_header_value</span>: <span class="bool-val">false</span>,
            <span class="ident">indent</span>: <span class="prelude-val">None</span>,
            <span class="ident">suffix</span>: <span class="string">&quot;\n&quot;</span>,
            <span class="ident">buf</span>: <span class="kw-2">&amp;mut</span> <span class="ident">f</span>,
        });

        <span class="macro">assert_eq!</span>(<span class="string">&quot;log\nmessage\n&quot;</span>, <span class="ident">written</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">format_indent_spaces</span>() {
        <span class="kw">let</span> <span class="ident">writer</span> <span class="op">=</span> <span class="ident">writer::Builder::new</span>()
            .<span class="ident">write_style</span>(<span class="ident">WriteStyle::Never</span>)
            .<span class="ident">build</span>();

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">f</span> <span class="op">=</span> <span class="ident">Formatter::new</span>(<span class="kw-2">&amp;</span><span class="ident">writer</span>);

        <span class="kw">let</span> <span class="ident">written</span> <span class="op">=</span> <span class="ident">write</span>(<span class="ident">DefaultFormat</span> {
            <span class="ident">timestamp</span>: <span class="prelude-val">None</span>,
            <span class="ident">module_path</span>: <span class="bool-val">true</span>,
            <span class="ident">target</span>: <span class="bool-val">false</span>,
            <span class="ident">level</span>: <span class="bool-val">true</span>,
            <span class="ident">written_header_value</span>: <span class="bool-val">false</span>,
            <span class="ident">indent</span>: <span class="prelude-val">Some</span>(<span class="number">4</span>),
            <span class="ident">suffix</span>: <span class="string">&quot;\n&quot;</span>,
            <span class="ident">buf</span>: <span class="kw-2">&amp;mut</span> <span class="ident">f</span>,
        });

        <span class="macro">assert_eq!</span>(<span class="string">&quot;[INFO  test::path] log\n    message\n&quot;</span>, <span class="ident">written</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">format_indent_zero_spaces</span>() {
        <span class="kw">let</span> <span class="ident">writer</span> <span class="op">=</span> <span class="ident">writer::Builder::new</span>()
            .<span class="ident">write_style</span>(<span class="ident">WriteStyle::Never</span>)
            .<span class="ident">build</span>();

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">f</span> <span class="op">=</span> <span class="ident">Formatter::new</span>(<span class="kw-2">&amp;</span><span class="ident">writer</span>);

        <span class="kw">let</span> <span class="ident">written</span> <span class="op">=</span> <span class="ident">write</span>(<span class="ident">DefaultFormat</span> {
            <span class="ident">timestamp</span>: <span class="prelude-val">None</span>,
            <span class="ident">module_path</span>: <span class="bool-val">true</span>,
            <span class="ident">target</span>: <span class="bool-val">false</span>,
            <span class="ident">level</span>: <span class="bool-val">true</span>,
            <span class="ident">written_header_value</span>: <span class="bool-val">false</span>,
            <span class="ident">indent</span>: <span class="prelude-val">Some</span>(<span class="number">0</span>),
            <span class="ident">suffix</span>: <span class="string">&quot;\n&quot;</span>,
            <span class="ident">buf</span>: <span class="kw-2">&amp;mut</span> <span class="ident">f</span>,
        });

        <span class="macro">assert_eq!</span>(<span class="string">&quot;[INFO  test::path] log\nmessage\n&quot;</span>, <span class="ident">written</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">format_indent_spaces_no_header</span>() {
        <span class="kw">let</span> <span class="ident">writer</span> <span class="op">=</span> <span class="ident">writer::Builder::new</span>()
            .<span class="ident">write_style</span>(<span class="ident">WriteStyle::Never</span>)
            .<span class="ident">build</span>();

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">f</span> <span class="op">=</span> <span class="ident">Formatter::new</span>(<span class="kw-2">&amp;</span><span class="ident">writer</span>);

        <span class="kw">let</span> <span class="ident">written</span> <span class="op">=</span> <span class="ident">write</span>(<span class="ident">DefaultFormat</span> {
            <span class="ident">timestamp</span>: <span class="prelude-val">None</span>,
            <span class="ident">module_path</span>: <span class="bool-val">false</span>,
            <span class="ident">target</span>: <span class="bool-val">false</span>,
            <span class="ident">level</span>: <span class="bool-val">false</span>,
            <span class="ident">written_header_value</span>: <span class="bool-val">false</span>,
            <span class="ident">indent</span>: <span class="prelude-val">Some</span>(<span class="number">4</span>),
            <span class="ident">suffix</span>: <span class="string">&quot;\n&quot;</span>,
            <span class="ident">buf</span>: <span class="kw-2">&amp;mut</span> <span class="ident">f</span>,
        });

        <span class="macro">assert_eq!</span>(<span class="string">&quot;log\n    message\n&quot;</span>, <span class="ident">written</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">format_suffix</span>() {
        <span class="kw">let</span> <span class="ident">writer</span> <span class="op">=</span> <span class="ident">writer::Builder::new</span>()
            .<span class="ident">write_style</span>(<span class="ident">WriteStyle::Never</span>)
            .<span class="ident">build</span>();

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">f</span> <span class="op">=</span> <span class="ident">Formatter::new</span>(<span class="kw-2">&amp;</span><span class="ident">writer</span>);

        <span class="kw">let</span> <span class="ident">written</span> <span class="op">=</span> <span class="ident">write</span>(<span class="ident">DefaultFormat</span> {
            <span class="ident">timestamp</span>: <span class="prelude-val">None</span>,
            <span class="ident">module_path</span>: <span class="bool-val">false</span>,
            <span class="ident">target</span>: <span class="bool-val">false</span>,
            <span class="ident">level</span>: <span class="bool-val">false</span>,
            <span class="ident">written_header_value</span>: <span class="bool-val">false</span>,
            <span class="ident">indent</span>: <span class="prelude-val">None</span>,
            <span class="ident">suffix</span>: <span class="string">&quot;\n\n&quot;</span>,
            <span class="ident">buf</span>: <span class="kw-2">&amp;mut</span> <span class="ident">f</span>,
        });

        <span class="macro">assert_eq!</span>(<span class="string">&quot;log\nmessage\n\n&quot;</span>, <span class="ident">written</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">format_suffix_with_indent</span>() {
        <span class="kw">let</span> <span class="ident">writer</span> <span class="op">=</span> <span class="ident">writer::Builder::new</span>()
            .<span class="ident">write_style</span>(<span class="ident">WriteStyle::Never</span>)
            .<span class="ident">build</span>();

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">f</span> <span class="op">=</span> <span class="ident">Formatter::new</span>(<span class="kw-2">&amp;</span><span class="ident">writer</span>);

        <span class="kw">let</span> <span class="ident">written</span> <span class="op">=</span> <span class="ident">write</span>(<span class="ident">DefaultFormat</span> {
            <span class="ident">timestamp</span>: <span class="prelude-val">None</span>,
            <span class="ident">module_path</span>: <span class="bool-val">false</span>,
            <span class="ident">target</span>: <span class="bool-val">false</span>,
            <span class="ident">level</span>: <span class="bool-val">false</span>,
            <span class="ident">written_header_value</span>: <span class="bool-val">false</span>,
            <span class="ident">indent</span>: <span class="prelude-val">Some</span>(<span class="number">4</span>),
            <span class="ident">suffix</span>: <span class="string">&quot;\n\n&quot;</span>,
            <span class="ident">buf</span>: <span class="kw-2">&amp;mut</span> <span class="ident">f</span>,
        });

        <span class="macro">assert_eq!</span>(<span class="string">&quot;log\n\n    message\n\n&quot;</span>, <span class="ident">written</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">format_target</span>() {
        <span class="kw">let</span> <span class="ident">writer</span> <span class="op">=</span> <span class="ident">writer::Builder::new</span>()
            .<span class="ident">write_style</span>(<span class="ident">WriteStyle::Never</span>)
            .<span class="ident">build</span>();

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">f</span> <span class="op">=</span> <span class="ident">Formatter::new</span>(<span class="kw-2">&amp;</span><span class="ident">writer</span>);

        <span class="kw">let</span> <span class="ident">written</span> <span class="op">=</span> <span class="ident">write_target</span>(
            <span class="string">&quot;target&quot;</span>,
            <span class="ident">DefaultFormat</span> {
                <span class="ident">timestamp</span>: <span class="prelude-val">None</span>,
                <span class="ident">module_path</span>: <span class="bool-val">true</span>,
                <span class="ident">target</span>: <span class="bool-val">true</span>,
                <span class="ident">level</span>: <span class="bool-val">true</span>,
                <span class="ident">written_header_value</span>: <span class="bool-val">false</span>,
                <span class="ident">indent</span>: <span class="prelude-val">None</span>,
                <span class="ident">suffix</span>: <span class="string">&quot;\n&quot;</span>,
                <span class="ident">buf</span>: <span class="kw-2">&amp;mut</span> <span class="ident">f</span>,
            },
        );

        <span class="macro">assert_eq!</span>(<span class="string">&quot;[INFO  test::path target] log\nmessage\n&quot;</span>, <span class="ident">written</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">format_empty_target</span>() {
        <span class="kw">let</span> <span class="ident">writer</span> <span class="op">=</span> <span class="ident">writer::Builder::new</span>()
            .<span class="ident">write_style</span>(<span class="ident">WriteStyle::Never</span>)
            .<span class="ident">build</span>();

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">f</span> <span class="op">=</span> <span class="ident">Formatter::new</span>(<span class="kw-2">&amp;</span><span class="ident">writer</span>);

        <span class="kw">let</span> <span class="ident">written</span> <span class="op">=</span> <span class="ident">write</span>(<span class="ident">DefaultFormat</span> {
            <span class="ident">timestamp</span>: <span class="prelude-val">None</span>,
            <span class="ident">module_path</span>: <span class="bool-val">true</span>,
            <span class="ident">target</span>: <span class="bool-val">true</span>,
            <span class="ident">level</span>: <span class="bool-val">true</span>,
            <span class="ident">written_header_value</span>: <span class="bool-val">false</span>,
            <span class="ident">indent</span>: <span class="prelude-val">None</span>,
            <span class="ident">suffix</span>: <span class="string">&quot;\n&quot;</span>,
            <span class="ident">buf</span>: <span class="kw-2">&amp;mut</span> <span class="ident">f</span>,
        });

        <span class="macro">assert_eq!</span>(<span class="string">&quot;[INFO  test::path] log\nmessage\n&quot;</span>, <span class="ident">written</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">format_no_target</span>() {
        <span class="kw">let</span> <span class="ident">writer</span> <span class="op">=</span> <span class="ident">writer::Builder::new</span>()
            .<span class="ident">write_style</span>(<span class="ident">WriteStyle::Never</span>)
            .<span class="ident">build</span>();

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">f</span> <span class="op">=</span> <span class="ident">Formatter::new</span>(<span class="kw-2">&amp;</span><span class="ident">writer</span>);

        <span class="kw">let</span> <span class="ident">written</span> <span class="op">=</span> <span class="ident">write_target</span>(
            <span class="string">&quot;target&quot;</span>,
            <span class="ident">DefaultFormat</span> {
                <span class="ident">timestamp</span>: <span class="prelude-val">None</span>,
                <span class="ident">module_path</span>: <span class="bool-val">true</span>,
                <span class="ident">target</span>: <span class="bool-val">false</span>,
                <span class="ident">level</span>: <span class="bool-val">true</span>,
                <span class="ident">written_header_value</span>: <span class="bool-val">false</span>,
                <span class="ident">indent</span>: <span class="prelude-val">None</span>,
                <span class="ident">suffix</span>: <span class="string">&quot;\n&quot;</span>,
                <span class="ident">buf</span>: <span class="kw-2">&amp;mut</span> <span class="ident">f</span>,
            },
        );

        <span class="macro">assert_eq!</span>(<span class="string">&quot;[INFO  test::path] log\nmessage\n&quot;</span>, <span class="ident">written</span>);
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="env_logger" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>